#pragma once

// ESP32 specific
// #include "driver/ledc.h"

// C++ system level
#include <functional>

// project specific
// #include "SpiderLib/NumberTypes.hpp"


namespace SpiderLib {

  class SNTP {
    public:

      SNTP(SNTP const&)           = delete;
      void operator=(SNTP const&) = delete;

      static SNTP& instance() {
        static SNTP sntp;
        return sntp;
      }

      bool inSync();

      void registerTimeSyncHandler(std::function<void()> f);

    private:

      SNTP();

      std::function<void()> syncEventHandler = [](){};

  };
}
